Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_deallocation.cpp	(revision 78)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_deallocation.cpp	(revision 81)
@@ -27,5 +27,100 @@
 	delete    in_CLOCK ;
 	delete    in_NRESET;
+
+	// ~~~~~[ Interface : "predict" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+	delete []  in_PREDICT_VAL                 ;
+	delete [] out_PREDICT_ACK                 ;
+	if (_param->_have_port_context_id)
+	delete []  in_PREDICT_CONTEXT_ID          ;
+	delete []  in_PREDICT_BTB_ADDRESS_SRC     ;
+	delete []  in_PREDICT_BTB_ADDRESS_DEST    ;
+	delete []  in_PREDICT_BTB_CONDITION       ;
+	delete []  in_PREDICT_BTB_LAST_TAKE       ;
+	delete []  in_PREDICT_BTB_IS_ACCURATE     ;
+	if (_param->_have_port_history)
+	delete []  in_PREDICT_DIR_HISTORY         ;
+	delete []  in_PREDICT_RAS_ADDRESS         ;
+	delete []  in_PREDICT_RAS_INDEX           ;
+// 	if (_param->_have_port_depth)
+// 	delete [] out_PREDICT_UPDATE_PREDICTION_ID;
+	
+	// ~~~~~[ Interface : "decod" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+	delete []  in_DECOD_VAL                   ;
+	delete [] out_DECOD_ACK                   ;
+	if (_param->_have_port_context_id)
+	delete []  in_DECOD_CONTEXT_ID            ;
+	delete []  in_DECOD_BTB_ADDRESS_SRC       ;
+	delete []  in_DECOD_BTB_ADDRESS_DEST      ;
+	delete []  in_DECOD_BTB_CONDITION         ;
+	delete []  in_DECOD_BTB_LAST_TAKE         ;
+	delete []  in_DECOD_RAS_ADDRESS           ;
+	delete []  in_DECOD_RAS_INDEX             ;
+	delete []  in_DECOD_MISS_PREDICTION       ;
+	if (_param->_have_port_depth)
+	delete []  in_DECOD_UPDATE_PREDICTION_ID  ;
+// 	if (_param->_have_port_depth)
+// 	delete [] out_DECOD_DEPTH                 ;
+	
+	// ~~~~~[ Interface : "branch_complete" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+	delete []  in_BRANCH_COMPLETE_VAL            ;
+	delete [] out_BRANCH_COMPLETE_ACK            ;
+	if (_param->_have_port_context_id)
+	delete []  in_BRANCH_COMPLETE_CONTEXT_ID     ;
+	if (_param->_have_port_depth)
+	delete []  in_BRANCH_COMPLETE_DEPTH          ;
+	delete []  in_BRANCH_COMPLETE_ADDRESS        ;
+	delete []  in_BRANCH_COMPLETE_FLAG           ;
+	delete [] out_BRANCH_COMPLETE_MISS_PREDICTION;
+	delete [] out_BRANCH_COMPLETE_TAKE           ;
+	delete [] out_BRANCH_COMPLETE_ADDRESS_SRC    ;
+	delete [] out_BRANCH_COMPLETE_ADDRESS_DEST   ;
+	
+	// ~~~~~[ Interface : "update" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+	delete [] out_UPDATE_VAL                  ;
+	delete []  in_UPDATE_ACK                  ;
+	if (_param->_have_port_context_id)
+	delete [] out_UPDATE_CONTEXT_ID           ;
+	delete [] out_UPDATE_MISS_PREDICTION      ;
+	delete [] out_UPDATE_DIRECTION_GOOD       ;
+	delete [] out_UPDATE_BTB_VAL              ;
+	delete [] out_UPDATE_BTB_ADDRESS_SRC      ;
+	delete [] out_UPDATE_BTB_ADDRESS_DEST     ;
+	delete [] out_UPDATE_BTB_CONDITION        ;
+	delete [] out_UPDATE_DIR_VAL              ;
+	if (_param->_have_port_history)
+	delete [] out_UPDATE_DIR_HISTORY          ;
+	delete [] out_UPDATE_RAS_VAL              ;
+	delete [] out_UPDATE_RAS_ADDRESS          ;
+	delete [] out_UPDATE_RAS_INDEX            ;
+	delete [] out_UPDATE_RAS_PREDICTION_IFETCH;
+
+	// ~~~~~[ Interface : "depth" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+	if (_param->_have_port_depth)
+	  {
+	delete [] out_DEPTH_NB_BRANCH;
+	delete [] out_DEPTH_TAIL;
+	  }
       }
+
+    // ~~~~~[ Internal ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    delete [] internal_PREDICT_ACK                     ;
+    delete [] internal_DECOD_ACK                       ;
+    delete [] internal_BRANCH_COMPLETE_ACK             ;
+    delete [] internal_BRANCH_COMPLETE_MISS_PREDICTION ;
+    delete [] internal_BRANCH_COMPLETE_TAKE            ;
+    delete [] internal_BRANCH_COMPLETE_ADDRESS_DEST    ;
+    delete [] internal_UPDATE_VAL                      ;
+    delete [] internal_UPDATE_CONTEXT_ID               ;
+    delete [] internal_UPDATE_DEPTH                    ;
+
+    // ~~~~~[ Register ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
+    delete [] reg_TOP;
+    delete [] reg_BOTTOM;
+    delete [] reg_NB_ELT;
+    delete [] reg_NB_ELT_NEED_UPDATE;
+    for (uint32_t i=0; i<_param->_nb_context; i++)
+      delete [] reg_UPDATE_PREDICTION_TABLE [i];
+    delete [] reg_UPDATE_PREDICTION_TABLE;
+
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_genMealy_branch_complete.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_genMealy_branch_complete.cpp	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_genMealy_branch_complete.cpp	(revision 81)
@@ -0,0 +1,105 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/include/Update_Prediction_Table.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace prediction_unit {
+namespace update_prediction_table {
+
+
+#undef  FUNCTION
+#define FUNCTION "Update_Prediction_Table::genMealy_branch_complete"
+  void Update_Prediction_Table::genMealy_branch_complete (void)
+  {
+    log_printf(FUNC,Update_Prediction_Table,FUNCTION,"Begin");
+    
+    for (uint32_t i=0; i<_param->_nb_inst_branch_complete; i++)
+      {
+	Tcontext_t          context   = (_param->_have_port_context_id)?PORT_READ(in_BRANCH_COMPLETE_CONTEXT_ID [i]):0;
+	Tdepth_t            depth     = (_param->_have_port_depth     )?PORT_READ(in_BRANCH_COMPLETE_DEPTH      [i]):0;
+	Tcontrol_t          miss      = false;
+	Tcontrol_t          take      = reg_UPDATE_PREDICTION_TABLE [context][depth]._last_take   ;
+	Taddress_t          addr_dest = reg_UPDATE_PREDICTION_TABLE [context][depth]._address_dest;
+	Tbranch_condition_t condition = reg_UPDATE_PREDICTION_TABLE [context][depth]._condition   ;
+
+	switch (condition)
+	  {
+	  case BRANCH_CONDITION_NONE_WITHOUT_WRITE_STACK          : // l.j
+	  case BRANCH_CONDITION_NONE_WITH_WRITE_STACK             : // l.jal
+	    {
+	      //miss      : always hit
+	      //addr_dest : know in decod stage
+	      break;
+	    }
+	  case BRANCH_CONDITION_FLAG_UNSET                        : // l.bnf
+	    {
+	      Tcontrol_t take_good = PORT_READ(in_BRANCH_COMPLETE_FLAG [i]) == 0;
+	      miss = (take != take_good);
+	      take = take_good;
+	      //addr_dest : know in decod stage
+	      break;
+	    }
+	  case BRANCH_CONDITION_FLAG_SET                          : // l.bf
+	    {
+// 	      log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * BRANCH_CONDITION_FLAG_SET");
+	      
+	      Tcontrol_t take_good = PORT_READ(in_BRANCH_COMPLETE_FLAG [i]) == 1;
+	      miss = (take != take_good);
+	      take = take_good;
+
+// 	      log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * flag      : %d",PORT_READ(in_BRANCH_COMPLETE_FLAG [i]));
+// 	      log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * take_good : %d",take_good);
+// 	      log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * miss      : %d",miss);
+	      
+	      //addr_dest : know in decod stage
+	      break;
+	    }
+	  case BRANCH_CONDITION_READ_REGISTER_WITHOUT_WRITE_STACK : // l.jr (rb!=r9)
+	  case BRANCH_CONDITION_READ_REGISTER_WITH_WRITE_STACK    : // l.jalr
+	  case BRANCH_CONDITION_READ_STACK                        : // l.jr (rb==r9)
+	    {
+	      Taddress_t addr_good = PORT_READ(in_BRANCH_COMPLETE_ADDRESS [i]);
+	      miss = ((take == 1) and
+		      (addr_dest = addr_good));
+	      take = 1;
+	      addr_dest = addr_good;
+	      break;
+	    }
+	  }
+
+// 	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * miss      : %d",miss);
+// 	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * take      : %d",take);
+// 	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * address   : %x",addr_dest);
+
+	internal_BRANCH_COMPLETE_MISS_PREDICTION [i] = miss     ;
+	internal_BRANCH_COMPLETE_TAKE            [i] = take     ;
+	internal_BRANCH_COMPLETE_ADDRESS_DEST    [i] = addr_dest;
+
+	PORT_WRITE(out_BRANCH_COMPLETE_MISS_PREDICTION [i], internal_BRANCH_COMPLETE_MISS_PREDICTION [i]);
+	PORT_WRITE(out_BRANCH_COMPLETE_TAKE            [i], internal_BRANCH_COMPLETE_TAKE            [i]);
+	PORT_WRITE(out_BRANCH_COMPLETE_ADDRESS_SRC     [i], reg_UPDATE_PREDICTION_TABLE [context][depth]._address_src);
+	PORT_WRITE(out_BRANCH_COMPLETE_ADDRESS_DEST    [i], internal_BRANCH_COMPLETE_ADDRESS_DEST    [i]);
+      }
+
+    log_printf(FUNC,Update_Prediction_Table,FUNCTION,"End");
+  };
+
+}; // end namespace update_prediction_table
+}; // end namespace prediction_unit
+}; // end namespace front_end
+}; // end namespace multi_front_end
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_genMealy_decod.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_genMealy_decod.cpp	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_genMealy_decod.cpp	(revision 81)
@@ -0,0 +1,56 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/include/Update_Prediction_Table.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace prediction_unit {
+namespace update_prediction_table {
+
+
+#undef  FUNCTION
+#define FUNCTION "Update_Prediction_Table::genMealy_decod"
+  void Update_Prediction_Table::genMealy_decod (void)
+  {
+    log_printf(FUNC,Update_Prediction_Table,FUNCTION,"Begin");
+    
+    for (uint32_t i=0; i<_param->_nb_inst_decod; i++)
+      {
+	Tcontrol_t miss = PORT_READ(in_DECOD_MISS_PREDICTION [i]);
+
+	if (miss)
+	  {
+	    // miss : need a empty slot.
+	    Tcontext_t context = (_param->_have_port_context_id)?PORT_READ(in_DECOD_CONTEXT_ID [i]):0;
+	    uint32_t   top     = reg_TOP[context];
+	    internal_DECOD_ACK [i] = (reg_UPDATE_PREDICTION_TABLE [context][top]._state == UPDATE_PREDICTION_STATE_EMPTY);
+	  }
+	else
+	  {
+	    internal_DECOD_ACK [i] = true;
+	  }
+
+	PORT_WRITE(out_DECOD_ACK [i], internal_DECOD_ACK [i]);
+      }
+
+    log_printf(FUNC,Update_Prediction_Table,FUNCTION,"End");
+  };
+
+}; // end namespace update_prediction_table
+}; // end namespace prediction_unit
+}; // end namespace front_end
+}; // end namespace multi_front_end
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_genMealy_predict.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_genMealy_predict.cpp	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_genMealy_predict.cpp	(revision 81)
@@ -0,0 +1,61 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/include/Update_Prediction_Table.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace prediction_unit {
+namespace update_prediction_table {
+
+
+#undef  FUNCTION
+#define FUNCTION "Update_Prediction_Table::genMealy_predict"
+  void Update_Prediction_Table::genMealy_predict (void)
+  {
+    log_printf(FUNC,Update_Prediction_Table,FUNCTION,"Begin");
+    
+    for (uint32_t i=0; i<_param->_nb_inst_predict; i++)
+      {
+	Tcontext_t context = (_param->_have_port_context_id)?PORT_READ(in_PREDICT_CONTEXT_ID [i]):0;
+	uint32_t   top     = reg_TOP[context];
+
+// 	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"PREDICT [%d] (genMealy)",i);
+// 	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * context     : %d",context);
+// 	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * top         : %d",top);
+// 	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * state       : %s",toString(reg_UPDATE_PREDICTION_TABLE [context][top]._state).c_str());
+// 	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * is accurate : %d",PORT_READ(in_PREDICT_BTB_IS_ACCURATE [i]));
+// 	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * need update : %d",reg_NB_ELT_NEED_UPDATE [context]);
+
+	// Not Full, accurate and no previous miss
+	// Optimisation to restart faster :
+	//   don't counter nb_elt_ko, but just nb_elt that need a update (change branch structure)
+	internal_PREDICT_ACK [i] = ((reg_UPDATE_PREDICTION_TABLE [context][top]._state == UPDATE_PREDICTION_STATE_EMPTY) and
+				    PORT_READ(in_PREDICT_BTB_IS_ACCURATE [i]) and
+				    (reg_NB_ELT_NEED_UPDATE [context] == 0));
+
+// 	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * ACK         : %d",internal_PREDICT_ACK [i]);
+
+	PORT_WRITE(out_PREDICT_ACK [i], internal_PREDICT_ACK [i]);
+      }
+
+    log_printf(FUNC,Update_Prediction_Table,FUNCTION,"End");
+  };
+
+}; // end namespace update_prediction_table
+}; // end namespace prediction_unit
+}; // end namespace front_end
+}; // end namespace multi_front_end
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_genMoore.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_genMoore.cpp	(revision 81)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_genMoore.cpp	(revision 81)
@@ -0,0 +1,112 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/include/Update_Prediction_Table.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace prediction_unit {
+namespace update_prediction_table {
+
+
+#undef  FUNCTION
+#define FUNCTION "Update_Prediction_Table::genMoore"
+  void Update_Prediction_Table::genMoore (void)
+  {
+    log_printf(FUNC,Update_Prediction_Table,FUNCTION,"Begin");
+
+    // ===================================================================
+    // =====[ DEPTH ]=====================================================
+    // ===================================================================
+
+    if (_param->_have_port_depth)
+      for (uint32_t i=0; i<_param->_nb_context; i++)
+	{
+	  PORT_WRITE(out_DEPTH_NB_BRANCH [i], reg_NB_ELT [i]);
+	  PORT_WRITE(out_DEPTH_TAIL      [i], reg_BOTTOM [i]);
+	}
+
+    // ===================================================================
+    // =====[ UPDATE ]====================================================
+    // ===================================================================
+
+    Tdepth_t tab_depth [_param->_nb_context];
+    for (uint32_t i=0; i<_param->_nb_context; i++)
+      tab_depth [i] = reg_BOTTOM [i];
+
+    for (uint32_t i=0; i<_param->_nb_inst_update; i++)
+      {
+	uint32_t   context = (reg_UPDATE_PRIORITY+i)%_param->_nb_context;
+	Tdepth_t   depth   = tab_depth[context];
+	state_t    state   = reg_UPDATE_PREDICTION_TABLE [context][depth]._state;
+	
+	Tcontrol_t val     = ((state == UPDATE_PREDICTION_STATE_OK) or
+			      (state == UPDATE_PREDICTION_STATE_KO));
+
+// 	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"UPDATE [%d] (genMoore)",i);
+// 	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * context     : %d",context);
+// 	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * depth       : %d",depth);
+// 	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * state       : %s",toString(state).c_str());
+// 	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * val         : %d",val);
+// 	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * addr_src    : %x",reg_UPDATE_PREDICTION_TABLE [context][depth]._address_src );
+// 	log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * addr_dest   : %x",reg_UPDATE_PREDICTION_TABLE [context][depth]._address_dest);
+
+	if (val)
+	  {
+	    Tbranch_condition_t cond    = reg_UPDATE_PREDICTION_TABLE [context][depth]._condition;
+		      
+	    Tcontrol_t          ifetch  = reg_UPDATE_PREDICTION_TABLE [context][depth]._ifetch_prediction;
+	    Tcontrol_t          btb_val = true;
+	    Tcontrol_t          dir_val = (ifetch and // not ifetch == static prediction
+					   ((cond == BRANCH_CONDITION_FLAG_UNSET) or
+					    (cond == BRANCH_CONDITION_FLAG_SET)));
+	    Tcontrol_t          ras_val = ((cond == BRANCH_CONDITION_NONE_WITH_WRITE_STACK) or
+					   (cond == BRANCH_CONDITION_READ_REGISTER_WITH_WRITE_STACK) or
+					   (cond == BRANCH_CONDITION_READ_STACK));
+	      
+	    if (_param->_have_port_context_id)
+	    PORT_WRITE(out_UPDATE_CONTEXT_ID            [i],context);
+	    PORT_WRITE(out_UPDATE_MISS_PREDICTION       [i],(state == UPDATE_PREDICTION_STATE_KO));
+	    PORT_WRITE(out_UPDATE_DIRECTION_GOOD        [i],reg_UPDATE_PREDICTION_TABLE [context][depth]._good_take   );
+	    PORT_WRITE(out_UPDATE_BTB_VAL               [i],btb_val);
+	    PORT_WRITE(out_UPDATE_BTB_ADDRESS_SRC       [i],reg_UPDATE_PREDICTION_TABLE [context][depth]._address_src );
+	    PORT_WRITE(out_UPDATE_BTB_ADDRESS_DEST      [i],reg_UPDATE_PREDICTION_TABLE [context][depth]._address_dest);
+	    PORT_WRITE(out_UPDATE_BTB_CONDITION         [i],cond);
+	    PORT_WRITE(out_UPDATE_DIR_VAL               [i],dir_val);
+	    if (_param->_have_port_history)
+	    PORT_WRITE(out_UPDATE_DIR_HISTORY           [i],reg_UPDATE_PREDICTION_TABLE [context][depth]._history     );
+	    PORT_WRITE(out_UPDATE_RAS_VAL               [i],ras_val);
+	    PORT_WRITE(out_UPDATE_RAS_ADDRESS           [i],reg_UPDATE_PREDICTION_TABLE [context][depth]._address_ras );
+	    PORT_WRITE(out_UPDATE_RAS_INDEX             [i],reg_UPDATE_PREDICTION_TABLE [context][depth]._index_ras   );
+	    PORT_WRITE(out_UPDATE_RAS_PREDICTION_IFETCH [i],ifetch);
+
+	    internal_UPDATE_CONTEXT_ID [i] = context;
+	    internal_UPDATE_DEPTH      [i] = depth;
+
+	    tab_depth[context] = (depth+1)%_param->_size_queue[context];
+	  }
+
+	internal_UPDATE_VAL [i] = val;
+	PORT_WRITE(out_UPDATE_VAL [i], internal_UPDATE_VAL [i]);
+      }
+
+    log_printf(FUNC,Update_Prediction_Table,FUNCTION,"End");
+  };
+
+}; // end namespace update_prediction_table
+}; // end namespace prediction_unit
+}; // end namespace front_end
+}; // end namespace multi_front_end
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
